// JavaScript Document
var historie_nacitani;
var objednavka_refresh;
$(document).on("pageshow", "#historie", function() {
	nacti_historii();
	historie_nacitani=setInterval(nacti_historii,10000);
	$('a[data-rel="back"]').show();
});
$(document).on("pagehide", "#historie", function() {
	clearInterval(historie_nacitani);
});
$(document).on("pagehide", "#order_detail", function() {
	clearTimeout(objednavka_refresh);
	$("#ui-timepicker-div").hide();
	$("#ui-datepicker-div").hide();
});

function nacti_historii(){
	if (localStorage.getItem("login_token") && localStorage.getItem("login_token")!=""){
		$("#order_telefon").val(localStorage.getItem("telefon"));
		var nocache = new Date().getTime();
		$.ajax({
		url: "http://www.facetaxi.cz/app/historie_jizd.php",
		type: "GET",
		crossDomain:true,
		dataType: "jsonp",
		data: '&telefon=' + localStorage.getItem("telefon") + '&login_token=' + localStorage.getItem("login_token") + '&nocache=4654' + nocache,
		beforeSend : function() {$.mobile.loading('show');},
		complete   : function() {$.mobile.loading('hide')},
		success: zpracujhistorii,
		error : function (response, ajaxOptions, thrownError) {
			//alert(thrownError);
			//alert(response.status);
			$( "#historie_content" ).html( response.status );
		  }
		});
	}
	else{
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	}
}

var zpracujhistorii=function processHistoryData(data){
	if (data.status == "false"){
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	}
	else{
		$( "#historie_content" ).html( data.historie ).trigger( "create" );
		$( "#historie_content ul li").attr('data-icon','arrow-1-e').trigger("refresh");
	}	
}

function zobrazitObjednavku(id){
	if (localStorage.getItem("login_token") && localStorage.getItem("login_token")!=""){
		$.ajax({
			url: "http://www.facetaxi.cz/app/detail_order.php",
			type: "GET",
			crossDomain:true,
			dataType: "jsonp",
			data: '&id_customer=' + localStorage.getItem("id_customer") + '&login_token=' + localStorage.getItem("login_token") + '&id_order=' + id,
			success: zpracujDetailObjednavky,
			error : function (response, ajaxOptions, thrownError) {
				$( "#status" ).html( response.status );
			  }
		});
	}
	else{
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	}
}


var zpracujDetailObjednavky=function processOrderDetail(data){
	if (data.status == "false"){
		alert(data.message);
	}
	else{
		
		if (data.preorder==1){
				$("#order_detail_content").html( data.message ).trigger( "create" );
				$("#order_detail_track_button").hide();
				zapni_kalendar();
		}
		else if (data.preorder==-5){
				$("#order_detail_content").html( data.message ).trigger( "create" );
				$("#order_detail_track_button").hide();
				objednavka_refresh=setTimeout(function(){zobrazitObjednavku(data.id_order);},5000);
		}
		else{
				$("#order_detail_content").html( data.message ).trigger( "create" );
				$("#order_detail_track_button").show();
				objednavka_refresh=setTimeout(function(){zobrazitObjednavku(data.id_order);},5000);
				
		}
		if (data.storno===1){
			$("#order_detail_storno_button").show();
			$("#order_detail_storno_button").on('click',function(){storno_order(data.id_order);return false;});
		}else{
			$("#order_detail_storno_button").hide()
		}
		id_order=data.id_order;
		$.mobile.changePage("#order_detail", { transition: "slidedown"});	
	}
}

function zapni_kalendar(){
	
	$('#upravit_datum_pristaveni').datebox({
		mode: "calbox",
		afterToday: true,
		beforeToday: false,
		dateFieldOrder: ["d","m","y"],
		maxDays: 30,
		useLang: "cs"
	});
	
	$('#upravit_cas_pristaveni').datebox({
		mode: "timeflipbox",
		afterToday: false,
		minuteStep: 5,
		useLang: "cs"
	});
	
}

function upravit_historie_cas(id_upravit){
	$.ajax({
		url: "http://www.facetaxi.cz/app/save_time_change.php",
		type: "GET",
		crossDomain:true,
		dataType: "jsonp",
		data: $("form#update_time_form").serialize()+'&id_customer=' + localStorage.getItem("id_customer") + '&login_token=' + localStorage.getItem("login_token"),
		success: myupravitcas,
		error : function (response, ajaxOptions, thrownError) {
			$( "#status" ).html( response.status );
		  }
	});
}

var myupravitcas=function processUpdateTimeData(data){
	alert(data.message);
}

$(document).on("pageshow", "#historie_old", function() {
	nacti_historii_old();
//	historie_nacitani=setInterval(nacti_historii,10000);
	$('a[data-rel="back"]').show();
});
$(document).on("pagehide", "#historie_old", function() {
	//clearInterval(historie_nacitani);
});

function nacti_historii_old(){
	if (localStorage.getItem("login_token") && localStorage.getItem("login_token")!=""){
		$("#order_telefon").val(localStorage.getItem("telefon"));
		var nocache = new Date().getTime();
		$.ajax({
		url: "http://www.facetaxi.cz/app/historie_jizd_stare.php",
		type: "GET",
		crossDomain:true,
		dataType: "jsonp",
		data: '&telefon=' + localStorage.getItem("telefon") + '&login_token=' + localStorage.getItem("login_token") + '&nocache=4654' + nocache,
		beforeSend : function() {$.mobile.loading('show');},
		complete   : function() {$.mobile.loading('hide')},
		success: zpracujhistorii_old,
		error : function (response, ajaxOptions, thrownError) {
			//alert(thrownError);
			//alert(response.status);
			$( "#historie_content_old" ).html( response.status );
		  }
		});
	}
	else{
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	}
}

var zpracujhistorii_old=function processHistoryData_old(data){
	if (data.status == "false"){
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	}
	else{
		$( "#historie_content_old" ).html( data.historie ).trigger( "create" );
		$( "#historie_content_old ul li").attr('data-icon','arrow-1-e').trigger("refresh");
	}	
}