// Configure properties individually

$( document ).on( "mobileinit", function() {
	$.mobile.loadingMessage = "Načítám data";
	$.mobile.ajaxEnabled = true;
	$.support.cors = true;
	$.mobile.allowCrossDomainPages = true;
	$.mobile.page.prototype.options.addBackBtn = true;

	$( "[data-role='header']" ).toolbar({
	  addBackBtn: true
	});

	var defaultTheme="c";
	$.mobile.theme = defaultTheme;
	$.mobile.page.prototype.options.theme = defaultTheme;
    // Navigation
	$.mobile.toolbar.prototype.options.backBtnText = "";
    $.mobile.page.prototype.options.backBtnText = "";
    $.mobile.page.prototype.options.addBackBtn      = true;
    $.mobile.page.prototype.options.backBtnTheme    = defaultTheme;
    // Page
    $.mobile.page.prototype.options.headerTheme = defaultTheme;  // Page header only
    $.mobile.page.prototype.options.contentTheme    = defaultTheme;
    $.mobile.page.prototype.options.footerTheme = defaultTheme;
    // Listviews
    $.mobile.listview.prototype.options.headerTheme = defaultTheme;  // Header for nested lists
    $.mobile.listview.prototype.options.theme           = defaultTheme;  // List items / content
    $.mobile.listview.prototype.options.dividerTheme    = defaultTheme;  // List divider
    $.mobile.listview.prototype.options.splitTheme   = defaultTheme;
    $.mobile.listview.prototype.options.countTheme   = defaultTheme;
	$.mobile.listview.prototype.options.icon = false;
    $.mobile.listview.prototype.options.filterTheme = defaultTheme;
    $.mobile.listview.prototype.options.filterPlaceholder = "Hledat...";
});


function debug(text){
	//alert (text);	
	console.log(text);
}

function onLoad() {
	document.addEventListener("deviceready", onDeviceReady, false);
}

// device APIs are available
//
function onDeviceReady() {
	document.addEventListener("pause", onPause, false);
	document.addEventListener("resume", onResume, false);
	$(".home_href").click(function() {
  		onResume();
	});
}

function onPause() {
    // Handle the pause event
}

function onResume() {
    $.mobile.changePage("#mainpage", { transition: "slidedown"});
    start_watch();
	$("#destinace").val('');
	$("#destination_text").html("<aside>B</aside><strong>Cílová adresa</strong>Zadejte či vyberte adresu");
	if (start_marker!=='NULL'){start_marker.setMap(null);}
	if (cil_marker!=='NULL'){cil_marker.setMap(null);}
	directionsDisplay.setDirections({routes: []});
	hide_cil();
}