// JavaScript Document
var directionsDisplay = new google.maps.DirectionsRenderer();
var directionsService = new google.maps.DirectionsService();
var map;
var map_initialized=0;
var global_marker=0;
var global_circle;
var gl;//Geolocation object
var prague = new google.maps.LatLng(50.085034, 14.447207);
var last_search=0;
var last_search_lat=0;
var last_search_lng=0;
var closest_taxikar=0;
var last_doba=0;
var last_doba_lat=0;
var last_doba_lng=0;
var last_doba_lat_t=0;
var last_doba_lng_t=0;
var current_position="";
var current_gps="";
var watchID = 'NULL';
var global_lat='';
var global_lng='';
var global_accuracy=5000;
var pristaveni_lat='';
var pristaveni_lng='';
var senzor_gps=0;
var markers_interval;
var markers= new Array();
var images= new Array();
var pozice= new Array();
var bypass_from=0;
var volnych_taxi=1;
var adresa_vlozena_timeout='NULL';
var existuje_cilova_adresa=0;
var centruj_mapu_dle_gps=1;
var finalni_adresa_pristaveni=0;
var google_adresa_ok=0;
var start_marker='NULL';
var cil_marker='NULL';

$(document).on("pageinit", "#mainpage", function() {
	//$('a[data-rel="back"]').hide();
	var interval=setInterval(function(){$("#postext").css("background-color","#FF0000");},3000);
	$("#from").on("input", null, null, function(){
			clearTimeout(adresa_vlozena_timeout);
			adresa_vlozena_timeout=setTimeout(vlozenaAdresa,5000);
			});
    $('form#polohaform').submit(function(){
		vlozenaAdresa();
        return false;
    });	
});
$(document).on("pageshow", "#mainpage", function(){
	/*if (sleduji_vuz===1){
		$("#setting_button").hide();
		$('a[data-rel="back"]').show();
	}
	else{
		$('a[data-rel="back"]').hide();
		$("#setting_button").show();
	}*/
	if (map_initialized==0){
		$("#mapa").css({
						top : "90px",
						height: $(window).height() - 140 + "px"
	
		});
		drawMap(prague); // Show default map
		map.panTo(prague);
		getMarkers();
		map_initialized=1;
		$("#cil_done").hide();
		$("#cil_write").show();
		google.maps.event.trigger(map, 'resize');
		spustmapu();
	}
	//start_watch();
	google.maps.event.trigger(map, 'resize');
	markers_interval=setInterval(getMarkers, 6000);
});
$(document).on("pagehide", "#mainpage", function(){
	clearInterval(markers_interval);
	$('a[data-rel="back"]').show();
});

var gps_timeout;
function start_watch(){
	centruj_mapu_dle_gps=1;
	finalni_adresa_pristaveni=0;
	$("#map_pin").show();
	var timeoutVal = 10 * 1000 * 1000;
	clearTimeout(adress_interval);
	clearTimeout(psani_interval);
	senzor_gps=1;
	var gps_options = { enableHighAccuracy: true, timeout: 120000 , maximumAge: 10000 };
	watchID="NULL";
	watchID = navigator.geolocation.watchPosition(
		displayPosition, 
		displayError,
		gps_options
	);
	clearInterval(gps_timeout);
	$("#gps_arrow").hide();$("#gps_search").show();
	$("#addresa_text").html("<aside>A</aside><strong>Hledáme adresu</strong>Vyčkejte či vyberte adresu přistavení");
	$("#destinace").val('');
	$("#destination_text").html("<aside>B</aside><strong>Cílová adresa</strong>Zadejte či vyberte adresu");
	if (cil_marker!=='NULL'){cil_marker.setMap(null);}
	directionsDisplay.setDirections({routes: []});
	$("#castka_text").html("");
}

function stop_watch(){
	centruj_mapu_dle_gps=0;
	$("#gps_arrow").show();$("#gps_search").hide();
	navigator.geolocation.clearWatch(watchID);
	clearInterval(gps_timeout);
	watchID="NULL";
	senzor_gps=0;
}

function displayPosition(position) {
  //zastavmapu();
  //google.maps.event.clearListeners(map, 'dragend');$("#map_pin").hide();
  var contentString = "<b>Timestamp:</b> " + parseTimestamp(position.timestamp) + "<br/><b>User location:</b> lat " + position.coords.latitude + ", long <br/>" + position.coords.longitude + ", accuracy " + position.coords.accuracy;
  var lat = position.coords.latitude;
  var lng = position.coords.longitude;
  var latlng = new google.maps.LatLng(lat, lng);
  var accuracy = position.coords.accuracy;
  //$("#postext").html(contentString);
  var ted=new Date().getTime();
  if (centruj_mapu_dle_gps===1 
  	  && ted>(last_search+2500) 
	  && accuracy<500
	  && (vzdalenost(lat,lng,last_search_lat,last_search_lng)>20 || ted>(last_search+12500))
	 ){
		last_search=new Date().getTime();
		last_search_lat=lat;
		last_search_lng=lng;
		global_accuracy=accuracy;
		var nova_adresa=ziskej_adresu(latlng);
		moveToLocation(lat,lng);
		pristaveni_lat=lat;
		pristaveni_lng=lng;
		global_lat=lat;
		global_lng=lng;
		spustmapu();
		if (accuracy<250){
				$("#gps_arrow").hide();$("#gps_search").hide();
		}
		else{
				$("#gps_arrow").show();$("#gps_search").hide();
		}
		clearInterval(gps_timeout);
		gps_timeout=setInterval(function(){$("#gps_arrow").show();$("#gps_search").hide();},15000); 
  }
  var hereyouare = new google.maps.LatLng(lat, lng);
	if(fixed_price===1){
		if ($("#destinace").val()!=""){
			$("#send_order_button_cont").html('Potvrdit obě adresy');
		}
		else{
			$("#send_order_button_cont").html('Zadejte cílovou adresu');
		}
	}
	else{
		$("#send_order_button_cont").html('Potvrdit adresu');
	}

  if (global_marker==0){
	var your_image = new google.maps.MarkerImage('images/your_position.png',
	  // This marker is 20 pixels wide by 32 pixels tall.
	  new google.maps.Size(18, 17),
	  // The origin for this image is 0,0.
	  new google.maps.Point(0,0),
	  // The anchor for this image is the base of the flagpole at 0,32.
	  new google.maps.Point(9, 9));
	  global_marker = new google.maps.Marker({
			position: hereyouare,
			map: map,
			title: "Jste zde!!",
			icon: your_image
	  });
	  global_circle = new google.maps.Circle({
		  center: latlng,
		  radius: global_accuracy,
		  map: map,
		  fillColor: '#fff',
		  fillOpacity: 0,
		  strokeColor: '#fff',
		  strokeOpacity: 0
		});
  }
  else{
	  global_marker.setOptions({
			position: hereyouare,
			map: map,
			title: "Sem jste se přesunul!"
		});
	  global_circle.setOptions({
		  center: hereyouare,
		  radius: global_accuracy,
		  map: map,
		});
  }
	if (centruj_mapu_dle_gps===1){
		//alert('GPS1');
		map.fitBounds(global_circle.getBounds());
		var zoom_level=map.getZoom();
		if (zoom_level<13){
			map.setZoom(13);
		}
		if (zoom_level>19){
			map.setZoom(19);
		}
	}
}

function ziskej_adresu(latlng){
	var geocoder = new google.maps.Geocoder();
	geocoder.geocode({'latLng': latlng}, function(results, status) {
	  if (status === google.maps.GeocoderStatus.OK) {
		var locationArray = results[0].formatted_address.split(',');
		$("#pristaveni").val(locationArray[0]);
		//$("#addresa_text").html("<aside>A</aside><strong>"+locationArray[0]+"</strong>"+locationArray[1]);
		$("#addresa_text").html("<aside><img src=\"images/icon-start-black.png\" alt=\"A\" /></aside><strong>"+locationArray[0]+"</strong>"+locationArray[1]);		
		odesli_polohu(latlng.lat(), latlng.lng(),10);
		pristaveni_lat=latlng.lat();
		pristaveni_lng=latlng.lng();
		//alert('Ziskana adresa');
		return locationArray[0];
		}
	  else {
		return("Geocoder failed due to: " + status);
	  }
	});
}

function souradnice_pristaveni(a,do_divu,results,status){
 if (status === google.maps.GeocoderStatus.OK) {
	var locationArray = results[0].formatted_address.split(',');
	var re = new RegExp("[a-zA-ZáčďéěíňóřšťůúýžÁČĎÉĚÍŇÓŘŠŤŮÚÝŽ0-9]{3,} [0-9]{1,}");
	if (results[0].geometry.location_type==='ROOFTOP'){//Google nalezl přímo zadanou adresu
		/*if (locationArray[0].match(re)){*/
			
			$("#pristaveni").val(locationArray[0]);
			//$("#"+do_divu).html("<aside>A</aside><strong>"+locationArray[0]+"</strong>"+locationArray[1]);
			$("#"+do_divu).html("<aside><img src=\"images/icon-start-black.png\" alt=\"A\" /></aside><strong>"+locationArray[0]+"</strong>"+locationArray[1]);
			pristaveni_lat=results[0].geometry.location.lat();
			pristaveni_lng=results[0].geometry.location.lng();
			moveToLocation(results[0].geometry.location.lat(), results[0].geometry.location.lng());
			current_gps=results[0].geometry.location;
			odesli_polohu(results[0].geometry.location.lat(), results[0].geometry.location.lng(),10);
			
			  // Add the marker začátku
			  set_start_marker(results[0].geometry.location);
			  
			clearTimeout(psani_interval);
			if ($("#destinace").val()!==''){
				//alert ('souradnice_pristaveni');
				calcRoute3($("#pristaveni").val(),$("#destinace").val());
			}
			$.mobile.changePage("#mainpage", { transition: "slidedown"});

	}
	else{//Nejsme na "ROOFTOP"
           if(results[0].geometry.location_type==='ZERO_RESULTS' && redirect ===1){
              alert('Nic takového google nezná');
            }
            else{
				  if (confirm('Vaše adresa nebyla rozeznána. Je adresa "'+a+'" spávně? ')) {
					  
					//$("#"+do_divu).html("<aside>A</aside><strong>"+a+"</strong>"+locationArray[0]);
					$("#"+do_divu).html("<aside><img src=\"images/icon-start-black.png\" alt=\"A\" /></aside><strong>"+a+"</strong>"+locationArray[0]);

					$("#pristaveni").val(a);
					
					pristaveni_lat=results[0].geometry.location.lat();
					pristaveni_lng=results[0].geometry.location.lng();
					moveToLocation(results[0].geometry.location.lat(), results[0].geometry.location.lng());
					current_gps=results[0].geometry.location;
					odesli_polohu(results[0].geometry.location.lat(), results[0].geometry.location.lng(),10);
					
					  // Add the marker začátku
					  set_start_marker(results[0].geometry.location);

					  clearTimeout(psani_interval);
					  if ($("#destinace").val()!==''){
						//$("#log").html($("#log").html()+'<br />'+$("#pristaveni").val() + " " +$("#destinace").val());
						//alert ('souradnice_pristaveni2');
						calcRoute3($("#pristaveni").val(),$("#destinace").val());
					  }
					  $.mobile.changePage("#mainpage", { transition: "slidedown"});

              		//alert('Ověřte číslo popisné');
				  }
            }
	}
 }
}

function souradnice_cilove(a,do_divu,results,status){
	 if (status === google.maps.GeocoderStatus.OK) {
		var locationArray = results[0].formatted_address.split(',');
		if (results[0].geometry.location_type!=='ROOFTOP'){//Nenalezené adresy neměníme dle google
			//$("#destination_text").html("<aside>B</aside><strong>"+a+"</strong>"+locationArray[0]);
			$("#destination_text").html("<aside><img src=\"images/icon-end-black.png\" alt=\"B\" /></aside><strong>"+a+"</strong>"+locationArray[0]);
			$("#destinace").val(a);
		}
		else{
			//$("#destination_text").html("<aside>B</aside><strong>"+locationArray[0]+"</strong>"+locationArray[1]);
			$("#destination_text").html("<aside><img src=\"images/icon-end-black.png\" alt=\"B\" /></aside><strong>"+locationArray[0]+"</strong>"+locationArray[1]);
			$("#destinace").val(locationArray[0]);
		}
		set_cil_marker(results[0].geometry.location);
	 }
	 else{
		alert ('Nepodařilo se převédst adresu na souřadnice'); 
	 }
	 
	 clearTimeout(psani_interval);
	 if ($("#destinace").val()!==''){
		//$("#log").html($("#log").html()+'<br />'+$("#pristaveni").val() + " " +$("#destinace").val());
		//alert ('souradnice_cilove');
		calcRoute3($("#pristaveni").val(),$("#destinace").val());
	 }
	 $.mobile.changePage("#mainpage", { transition: "slidedown"});
}


function ziskej_souradnice(a,do_divu){
	var geocoder = new google.maps.Geocoder();
	geocoder.geocode({'address': a+", Praha"}, function(results, status) {
		if (do_divu==='addresa_text'){//Zpracování výsledku pro ADRESU PŘISTAVENÍ
			souradnice_pristaveni(a,do_divu,results,status);
		}
		else{//Zpracování výsledku pro CÍLOVOU ADRESU
			souradnice_cilove(a,do_divu,results,status);
		}
	});
}



function displayError(error) {
var errors = {
		1: 'Není oprávnění k přístupu k GPS poloze, prosím zadejte adresu ručně',
		2: 'Nepodařilo se zjistit polohu, prosím zadejte adresu ručně',
		3: 'GPS senzor nevrátil polohu, prosím zadejte adresu ručně'
	};
	alert("Error: " + errors[error.code]);		
}

function drawMap(latlng) {
	//directionsDisplay = new google.maps.DirectionsRenderer();
	//directionsService = new google.maps.DirectionsService();
	var myOptions = {
		zoom: 10,
		center: latlng,
		'disableDefaultUI':true,
		 zoomControl:true,
		 zoomControlOptions: {
		  style:google.maps.ZoomControlStyle.SMALL,
		  position:google.maps.ControlPosition.LEFT_BOTTOM
		 },
		mapTypeId: google.maps.MapTypeId.ROADMAP
	};
	/*var height = $(window).height() - 60;
	var width = $(window).width();
	
	$("#mapa").height(height);
	$("#mapa").width(width);
	$("#mapa").css("top","40px !important");*/

	map = new google.maps.Map(document.getElementById("mapa"), myOptions);
	directionsDisplay.setMap(map);
	var set = google.maps.InfoWindow.prototype.set;
    google.maps.InfoWindow.prototype.set = function (key, val) {
        if (key === 'map') {
            if (!this.get('noSupress')) {
                //console.log('This InfoWindow is supressed. To enable it, set "noSupress" option to true');
                return;
            }
        }
        set.apply(this, arguments);
    }
}

function moveToLocation(lat, lng){
	var center = new google.maps.LatLng(lat, lng);
	var zoom_level=map.getZoom();
	if (zoom_level<13){
		map.setZoom(13);
	}
	if (zoom_level>20){
		map.setZoom(20);
	}
	//alert (lat + " " +lng + " zoom:" + zoom_level);
	setTimeout(function(){ map.panTo(center)},100);
}

var adress_interval;
var psani_interval;

function spustmapu(){
		google.maps.event.addListener(map, "dragend", function() {
			if (finalni_adresa_pristaveni===0){
				$("#map_pin").show();
				getAdress();
				stop_watch();
				if (start_marker!=='NULL'){
					start_marker.setMap(null);
				}
			}
		});
	$("#addresa_text").show();
	$("#addresa_input").hide();
}

function zastavmapu(){
	stop_watch();
	google.maps.event.clearListeners(map, 'dragend');
	$("#map_pin").hide();
	clearTimeout(adress_interval);
	$("#gps_arrow").show();$("#gps_search").hide();
}

function zastavmapu_pen(){
	stop_watch();
	google.maps.event.clearListeners(map, 'dragend');
	$("#map_pin").hide();
	clearTimeout(adress_interval);
	$.mobile.changePage("#vyber_adresu", { transition: "slidedown"});	
	$("#addresa_start_input").css("display","inline");
	$("#from").focus();
	//$("#from").val('');
}

function opakovatAdresu(addr){
	$("#pristaveni").val(addr);
	bypass_from=1;
	senzor_gps=0;
	$.mobile.changePage("#objednavka", { transition: "slidedown"});	
}

function vlozenaAdresa(){
			debug ("vlozenaAdresa");
	stop_watch();
	zastavmapu();
}

function AdresaFinished(){
	stop_watch();
	zastavmapu();
	var ted=new Date().getTime();
	var nova_adresa=$("#from").val();
	clearTimeout(adress_interval);
	clearTimeout(psani_interval);
	ziskej_souradnice(nova_adresa,'addresa_text');
	$("#from_naseptavac").html('');
	$("#destination_naseptavac").html('');
	google.maps.event.clearListeners(map, 'dragend');$("#map_pin").hide();
}

function getAdress(){
	var center = map.getCenter();
	debug ("getadress");
	stop_watch();
	clearTimeout(psani_interval);
	var ted=new Date().getTime();
	if (ted>(last_search+2500) && vzdalenost(center.lat(),center.lng(),last_search_lat,last_search_lng)>20){
		var nova_adresa=ziskej_adresu(center);
		$("#pristaveni").val(nova_adresa);
		last_search=new Date().getTime();
		last_search_lat=center.lat();
		last_search_lng=center.lng();
		clearTimeout(adress_interval);
	}
	else{
		clearTimeout(adress_interval);
		adress_interval=setTimeout(getAdress,500);
	}
}

function toogle_cil(){
	if ($("#destination_tr").is(":visible")){
		/*Schovat Cíl*/
		hide_cil();
	}
	else{
		/*Zobrazit Cíl*/
		show_cil();
	}
}

function show_cil(){
	$("#destination_tr").css("display","table-row");
	finalni_adresa_pristaveni=1;
	/*Posuneme o 40px dolů*/
	//$("#cil").hide();
	$("#cil").css("top","210px");
	$("#cil_flag").hide();
	$("#cil_flag_active").show();
	$("#map_castka").show();
	$("#watch_td").hide();
	$("#send_order_button_cont").html('Potvrdit obě adresy');
	/*$("#mapa").css({
					top : "140px",
					height: $(window).height() - 190 + "px"

				});

	google.maps.event.trigger(map, 'resize');*/
	//AdresaFinished();
	stop_watch();
	zastavmapu();
	google.maps.event.clearListeners(map, 'dragend');$("#map_pin").hide();
	  var pristaveni_cord = new google.maps.LatLng(pristaveni_lat, pristaveni_lng);
	  set_start_marker(pristaveni_cord);
}	


function hide_cil(){
	$("#destination_tr").hide();
	existuje_cilova_adresa=0;
	finalni_adresa_pristaveni=0;
	/*Posuneme o 40px nahoru*/
	$("#cil").show();
	$("#cil").css("top","110px");
	$("#cil_flag").show();
	$("#cil_flag_active").hide();
	$("#watch_td").show();
	$("#map_castka").hide();
	$("#castka_text").html('');
	$("#send_order_button_cont").html('Potvrdit adresu přistavení');
	if (cil_marker!=='NULL'){//Schováme marker a trasu!
		cil_marker.setMap(null);
		directionsDisplay.setDirections({routes: []});
		var center = new google.maps.LatLng(pristaveni_lat, pristaveni_lng);
		map.panTo(center);
	}
	/*$("#mapa").css({
					top : "90px",
					height: $(window).height() - 140 + "px"

				});
	google.maps.event.trigger(map, 'resize');*/
	$("#destinace").val('');
	//$("#destination_text").html("<aside>B</aside><strong>Cílová adresa</strong>Zadejte či vyberte adresu");	
	$("#destination_text").html("<aside><img src=\"images/icon-end-black.png\" alt=\"B\" /></aside><strong>Cílová adresa</strong>Zadejte či vyberte adresu");	
}

function zastavmapu_cil(){
	debug ("zastavmapu_cil");
	stop_watch();
	google.maps.event.clearListeners(map, 'dragend');
	$("#map_pin").hide();
	clearTimeout(adress_interval);
	$.mobile.changePage("#vyber_cil", { transition: "slidedown"});	
	//$("#destination").val('');
	$("#destination").focus();
}

function CilFinished(){
	stop_watch();
	zastavmapu();
	var ted=new Date().getTime();
	var nova_adresa=$("#destination").val();
	$("#from_naseptavac").html('');
	$("#destination_naseptavac").html('');
	clearTimeout(adress_interval);
	ziskej_souradnice(nova_adresa,'destination_text');
	clearTimeout(psani_interval);
	calcRoute3($("#pristaveni").val(),$("#destination").val());
	finalni_adresa_pristaveni=1;
	existuje_cilova_adresa=1;
	$.mobile.changePage("#mainpage", { transition: "slidedown"});
	$("#send_order_button_cont").html('Potvrdit obě adresy');
}

function set_start_marker(pos){
	  if (start_marker!=='NULL'){
		start_marker.setMap(map);
		start_marker.setPosition(pos);
	  }
	  else{
		  var start_marker_icon = new google.maps.MarkerImage('images/icon-start.png',
			  // This marker is 20 pixels wide by 32 pixels tall.
			  new google.maps.Size(30, 30),
			  // The origin for this image is 0,0.
			  new google.maps.Point(0,0),
			  // The anchor for this image is the base of the flagpole at 0,32.
			  new google.maps.Point(15, 28));
		  var marker_shape = {
			  coord: [1, 1, 1, 20, 18, 20, 18 , 1],
			  type: 'poly'
		  };

		  start_marker = new google.maps.Marker({
			position: pos,
			shape: marker_shape,
			icon: start_marker_icon,
			title: "Adresa přistavení",
			map: map
		  });
	  }	
}

function set_cil_marker(pos){
	if (cil_marker!=='NULL'){
		cil_marker.setMap(map);
		cil_marker.setPosition(pos);
	}
	else{
		  var end_marker_icon = new google.maps.MarkerImage('images/icon-end.png',
			  // This marker is 20 pixels wide by 32 pixels tall.
			  new google.maps.Size(30, 30),
			  // The origin for this image is 0,0.
			  new google.maps.Point(0,0),
			  // The anchor for this image is the base of the flagpole at 0,32.
			  new google.maps.Point(15, 28));
		  var marker_shape = {
			  coord: [1, 1, 1, 20, 18, 20, 18 , 1],
			  type: 'poly'
		  };

		  cil_marker = new google.maps.Marker({
			position: pos,
			shape: marker_shape,
			icon: end_marker_icon,
			title: "Cílová adresa",
			map: map
		  });
	}
}


  function calcRoute3(adresa_start,adresa_cil) {
    var zacatek = adresa_start + ", Praha";
    var cil = adresa_cil + ", Praha";
    var waypts = [];
    var request = {
        origin:zacatek, 
        destination:cil,
        waypoints: waypts,
        optimizeWaypoints: false,
		provideRouteAlternatives: true,
        travelMode: google.maps.DirectionsTravelMode.DRIVING
    };
	//$("#log").html($("#log").html()+'<br />'+zacatek + " " +cil);
    directionsService.route(request, function(response, status) {
	//$("#log").html($("#log").html()+'<br />Status: '+status);
      if (status === google.maps.DirectionsStatus.OK) {
		/*alert(response.routes[0].distance.value);
		alert(response.routes[1].distance.value);
		alert(response.routes[2].distance.value);*/
	 var route='NULL';
	 var distance=0;
	 var nejkratsi=0;
	 var nejkratsi_value=10000000;
	 for (var r = 0; r < response.routes.length; r++){
		 route=response.routes[r];
		 distance = 0;
		 for (var i = 0; i < route.legs.length; i++) {
			distance+=route.legs[i].distance.value;
		 }
		 //alert ("Distance"+r+": " +distance);
		 if (distance<nejkratsi_value){
			nejkratsi_value=distance;
			nejkratsi=r; 
		 }
	 }
	 //alert ("Nejkratsi cesta má " +nejkratsi_value + "m a je to trasa " + nejkratsi );

		zastavmapu();
		debug ("calcRoute3");
		stop_watch();
		//alert ("calcRoute3");
		directionsDisplay.setMap(map);
		directionsDisplay.setOptions({ 
				preserveViewport: true,
				suppressMarkers: true,
				polylineOptions: {
					strokeWeight: 4,
					strokeOpacity: 0.7,
					strokeColor:  '#ff0000' 
				}
		});
		directionsDisplay.setDirections(response);
        /*directionsDisplay.setDirections(
				{
                    directions: response,
                    routeIndex: nejkratsi
                }
		);*/
        showSteps3(response,id_order,nejkratsi);
      }
    });
  }
  function showSteps3(directionResult,id_order,r) {
    var distance = 0;
    var doba= 0;
    var myRoute = directionResult.routes[r];
	//var bounds = new google.maps.LatLngBounds();
    for (var i = 0; i < myRoute.legs.length; i++) {
      distance=distance+myRoute.legs[i].distance.value;
      doba=doba+myRoute.legs[i].duration.value;
    }
	google.maps.event.addListenerOnce(map, 'idle', function() {
    	map.fitBounds(myRoute.bounds);
	});
	doba=Math.round(doba/60*1.05);
	var nastup=35;
	var kc_km=16.9;
	var kc_cekani=6;
	var cena = Math.round(nastup + distance*0.001*kc_km*1.01);
	distance = Math.round(distance*0.01)/10;
	$("#odhad_cena").html(cena + " Kč");
	$("#castka_text").html(cena);
	$("#odhad_km").html(distance + " Km");
	$("#odhad_doba").html(doba + " min.");
  }

function parseTimestamp(timestamp) {
	var d = new Date(timestamp);
	var day = d.getDate();
	var month = d.getMonth() + 1;
	var year = d.getFullYear();
	var hour = d.getHours();
	var mins = d.getMinutes();
	var secs = d.getSeconds();
	var msec = d.getMilliseconds();
	return day + "." + month + "." + year + " " + hour + ":" + mins + ":" + secs + "," + msec;
}

function vzdalenost( lat1,  lon1,  lat2,  lon2)
{
	  var R = 6371; // Radius of the earth in km
	  var dLat = deg2rad(lat2-lat1);  // deg2rad below
	  var dLon = deg2rad(lon2-lon1); 
	  var a = 
		Math.sin(dLat/2) * Math.sin(dLat/2) +
		Math.cos(deg2rad(lat1)) * Math.cos(deg2rad(lat2)) * 
		Math.sin(dLon/2) * Math.sin(dLon/2)
		; 
	  var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a)); 
	  var d = 1000 * R * c;
	//Vrátí vzdálenost v metrech
	return d;
}
function deg2rad(deg) {
  return deg * (Math.PI/180)
}

function odesli_polohu(lat,lng,accuracy){
	if (localStorage.getItem("login_token") && localStorage.getItem("login_token")!=""){
		global_lat=lat;$("#pristaveni_lat").val(global_lat);
		global_lng=lng;$("#pristaveni_lng").val(global_lng);
		$("#order_telefon").val(localStorage.getItem("telefon"));
		$.ajax({
		url: "http://www.facetaxi.cz/app/set_poloha.php",
		type: "GET",
		crossDomain:true,
		dataType: "jsonp",
		data: '&id=' + localStorage.getItem("id_customer") + '&login_token=' + localStorage.getItem("login_token") + '&lat=' + lat + '&lng=' + lng + '&acc=' + global_accuracy+ '&gps=' + senzor_gps,
		beforeSend : function() {$.mobile.loading('show');},
		complete   : function() {$.mobile.loading('hide')},
		success: mypoloha,
		error : function (response, ajaxOptions, thrownError) {
			//alert(thrownError);
			//alert(response.status);
			//$( "#status" ).html( response.status );
		  }
		});
	}
}

var mypoloha=function processPolohaData(data){
	/*Zatím nic*/
}

  /*Zobrazování taxíků na mapě - všechny/ty co jedou ke mě je řešeno v PHP skriptu*/

  /*Showing taxis and reloading list of positions*/
  function getMarkers(){
		$.ajax({
		url: "http://www.facetaxi.cz/app/remoteData.php",
		type: "GET",
		crossDomain:true,
		dataType: "jsonp",
		data: '&id=' + localStorage.getItem("id_customer") + '&login_token=' + localStorage.getItem("login_token") + '&lat=' + pristaveni_lat + '&lng=' + pristaveni_lng,
		complete   : function() {$.mobile.loading('hide')},
		success: zobrazAuticka,
		error : function (response, ajaxOptions, thrownError) {
			alert(thrownError);
			//alert(response.status);
		  }
		});
  }
  
zobrazAuticka=function nastavAuticka(data) {
	var volnych_taxi=data.volnych;
	if (data.status == "false"){
		alert( data.message );
	}
	else{
		//alert (data.id_order + " id_order ");
		if (data.id_order!==0 && sleduji_vuz===1){
			//Změníme header hlavní stránky
			centruj_mapu_dle_gps=0;
			directionsDisplay.setMap(map);
			directionsDisplay.setOptions( { suppressMarkers: false, preserveViewport: true } );
			$("#mainpage_normal_h1").hide();
			$("#mainpage_order_h1").show();
			google.maps.event.clearListeners(map, 'dragend');$("#map_pin").hide();
			
			if (data.order_text!==''){
				/*Objednávka se již jede nebo je přistaveno*/
				$("#order_text").html(data.order_text);
				if(data.existuje_cil===1){//Existuje cílová adresa
					//alert('existuje_cil');
					var adresa_pristaveni = new google.maps.LatLng(data.lat,data.lng);
					set_start_marker(adresa_pristaveni);
					var geocoder = new google.maps.Geocoder();
					geocoder.geocode({'address': data.cil+", Praha"}, function(results, status) {
						set_cil_marker(results[0].geometry.location);
						var request = {
							origin:adresa_pristaveni, 
							destination:results[0].geometry.location,
							travelMode: google.maps.DirectionsTravelMode.DRIVING
						};
						directionsService.route(request, function(response, status) {
						  if (status == google.maps.DirectionsStatus.OK) {
							directionsDisplay.setMap(map);
							directionsDisplay.setOptions({ 
									preserveViewport: false,
									suppressMarkers: true,
									markerOptions: {map:null},
									polylineOptions: {
										strokeWeight: 4,
										strokeOpacity: 0.7,
										strokeColor:  '#CC00CC' 
									}
							});
							directionsDisplay.setDirections(response);
						  }
						});
					});
				}
				else{//Neexistuje cílová adresa, necháme zobrazenu pouze adresu přistavení
					//alert ('adresa přistavení' + data.lat +data.lng);
					var adresa_pristaveni = new google.maps.LatLng(data.lat,data.lng);
					set_start_marker(adresa_pristaveni);
					directionsDisplay.setDirections({routes: []});
				}
			}
			else{
				/*Taxi se přistavuje*/
				calcRoute2(data.lat,data.lng,data.lat2,data.lng2,data.id_order);
				var adresa_pristaveni = new google.maps.LatLng(data.lat,data.lng);
				set_start_marker(adresa_pristaveni);
			}
		}
		else{
			//Má objednávku?
			if (data.ma_objednavku===1){
				$(".h1_order_icon").show();

			}
			else{
				$(".h1_order_icon").hide();
			}
			
			if (volnych_taxi===0 && sleduji_vuz===0){
				$("#mainpage_normal_h1").hide();
				$("#mainpage_order_h1").show();
				$("#order_text").html('Není volný vůz');
			}
			else{
				$("#mainpage_normal_h1").show();
				$("#mainpage_order_h1").hide();
				/*directionsDisplay.setMap(map);
				directionsDisplay.setOptions( { suppressMarkers: true } );*/
			}
		}
		if ((data.taxametr>30 || data.id_order!=0) && sleduji_vuz==1){
			//Sledujeme vůz
			$("#map_pin").hide();
			$("#polohaform").hide();
			if (data.taxametr>30){//Již nelze stornovat
				$("#navbar1").hide();
				$("#navbar2").hide();
				$("#navbar3").show();
				$("#storno_button_main").hide();
			}
			else{
				$("#navbar1").hide();
				$("#navbar2").show();
				$("#navbar3").hide();
			}
		}
		else{
			//Nesledujeme vůz
			/*$("#map_pin").show();*/
			$("#polohaform").show();
			$("#navbar1").show();
			$("#navbar2").hide();
			$("#navbar3").hide();
			sleduji_vuz=0;
		}
		closest_taxikar=data.closest_id_taxikar;
		$("#id_taxikar").val(closest_taxikar);
		var shape = {
			coord: [1, 1, 1, 20, 18, 20, 18 , 1],
			type: 'poly'
    	};
		//Úprava a promazání markerů, které nejsou aktivní a úprava aktuálních
		for(var id_taxikar in markers){
		  /*Skryjeme ty co nejsou a pokud sledujeme vůz, tak ty co nás nezajimají*/
		  if (typeof data.taxikari[id_taxikar] === "undefined"
		  		|| (sleduji_vuz===1 && (data.taxikari[id_taxikar].barva==='green' || data.taxikari[id_taxikar].barva=== 'yellow'))){
			markers[id_taxikar].setMap(null);
			/*markers[id_taxikar].setOptions({
					position: new google.maps.LatLng(10, 10),
					map: map,
					title: "Odhlášen"
				});*/
		  }
		  else{
		  images[id_taxikar] = new google.maps.MarkerImage(data.taxikari[id_taxikar].img,
		  // This marker is 20 pixels wide by 32 pixels tall.
		  new google.maps.Size(30, 30),
		  // The origin for this image is 0,0.
		  new google.maps.Point(0,0),
		  // The anchor for this image is the base of the flagpole at 0,32.
		  new google.maps.Point(15, 15));
		  pozice[id_taxikar]=new google.maps.LatLng(data.taxikari[id_taxikar].lat, data.taxikari[id_taxikar].lng);
		  markers[id_taxikar].setOptions({
				  position: pozice[id_taxikar],
				  map: map,
				  shape: shape,
				  icon: images[id_taxikar],
				  title: data.taxikari[id_taxikar].name,
				  zIndex: parseInt(1000+data.taxikari[id_taxikar].c)
			  });
		  //if (locations[id][6]!='grey'){attachListener(marker, id);}else{unattachListener(marker, id);}
		  }
		}
		//Načtení nových dat
		for (id_taxikar in data.taxikari){
			 var ted=new Date().getTime();
			 if (id_taxikar==data.closest_id_taxikar){
				 //alert (pristaveni_lat + ' ' +pristaveni_lng + ' ' +last_doba_lat + ' ' +last_doba_lng);
				 //alert (vzdalenost(pristaveni_lat,pristaveni_lng,last_doba_lat,last_doba_lng));
				 //alert (vzdalenost(data.taxikari[id_taxikar].lat,data.taxikari[id_taxikar].lng,last_doba_lat_t,last_doba_lng_t));
				if (vzdalenost(pristaveni_lat,pristaveni_lng,last_doba_lat,last_doba_lng)>100 || vzdalenost(data.taxikari[id_taxikar].lat,data.taxikari[id_taxikar].lng,last_doba_lat_t,last_doba_lng_t)>100){
				last_doba=new Date().getTime();
				last_doba_lat=pristaveni_lat;
				last_doba_lng=pristaveni_lng;
				last_doba_lat_t=data.taxikari[id_taxikar].lat;
				last_doba_lng_t=data.taxikari[id_taxikar].lng;
				calcRoute(data.taxikari[id_taxikar].lat, data.taxikari[id_taxikar].lng);
				}
			  }
			  /*Přidáme pouze neexistujici a zároveň ty co potřebujeme sledovat*/
			  if (markers[id_taxikar]===undefined && 
			      (sleduji_vuz==0
				  	|| (sleduji_vuz==1 && (data.taxikari[id_taxikar].barva==='blue' || data.taxikari[id_taxikar].barva==='violet' || data.taxikari[id_taxikar].barva==='red')))
				  ){//Add marker
				images[id_taxikar] = new google.maps.MarkerImage(data.taxikari[id_taxikar].img,
				// This marker is 20 pixels wide by 32 pixels tall.
				new google.maps.Size(30, 30),
				// The origin for this image is 0,0.
				new google.maps.Point(0,0),
				// The anchor for this image is the base of the flagpole at 0,32.
				new google.maps.Point(15, 15));
				
				pozice[id_taxikar] = new google.maps.LatLng(data.taxikari[id_taxikar].lat, data.taxikari[id_taxikar].lng);
				var marker = new google.maps.Marker({
					position: pozice[id_taxikar],
					map: map,
					icon: images[id_taxikar],
					shape: shape,
					title: data.taxikari[id_taxikar].name,
					zIndex: parseInt(1000+data.taxikari[id_taxikar].c)
				});
				//if (locations[id][6]!='grey'){attachListener(marker, id);}else{unattachListener(marker, id);}
				markers[id_taxikar]=marker;
			  }
		}
	}
  }

  function calcRoute(lat,lng) {
    var taxikar = new google.maps.LatLng(lat,lng);
    var moje_poloha = new google.maps.LatLng(pristaveni_lat,pristaveni_lng);
    var waypts = [];
    var request = {
        origin:taxikar, 
        destination:moje_poloha,
        waypoints: waypts,
        optimizeWaypoints: false,
        travelMode: google.maps.DirectionsTravelMode.DRIVING
    };
    directionsService.route(request, function(response, status) {
      if (status == google.maps.DirectionsStatus.OK) {
        showSteps(response);
      }
    });
  }
      
  function showSteps(directionResult) {
    var distance = 0;
    var doba= 0;
    var myRoute = directionResult.routes[0];
    for (var i = 0; i < myRoute.legs.length; i++) {
      //distance=distance+myRoute.legs[i].distance.value;
      doba=doba+myRoute.legs[i].duration.value;
      doba=Math.round(doba/60*1.2);
    }
	/*google.maps.event.addListenerOnce(map, 'idle', function() {
    	map.fitBounds(myRoute.bounds);
	});*/
	if (doba<3){doba=3;}
	$("#ft_content").html('FACETAXI');
	$("#dojezd").html(doba);
	$("#pristaveni_min").val(doba);
	$("#minut").show();
	$("#do_minut").show();
    /*document.getElementById('prijedu_za').innerHTML=' <strong>' + doba + ' minut'+str_addition+'</strong><br />'+Math.round(distance/100)/10+'km';
    document.getElementById('prijedu_za').href='http://www.face-taxi.cz/taxi3.php?obsazen=4&id_order=<?=$order['id_order'];?>&prijezd='+ doba;*/
  }
  
  function calcRoute2(lat,lng,lat2,lng2,id_order) {
	//alert (lat + 'calc 2'+lng+ 'calc 2'+lat2+ 'calc 2'+lng2);
	var poloha_pristaveni = new google.maps.LatLng(lat,lng);
    var taxikar = new google.maps.LatLng(lat2,lng2);
    var waypts = [];
    var request = {
        origin:taxikar, 
        destination:poloha_pristaveni,
        waypoints: waypts,
        optimizeWaypoints: false,
        travelMode: google.maps.DirectionsTravelMode.DRIVING
    };
    directionsService.route(request, function(response, status) {
      if (status == google.maps.DirectionsStatus.OK) {
		zastavmapu();
		stop_watch();
		/*Nebudeme zobrazovat trasu kudy se přistavuje taxikář - jezdí jinuty. Jen zobrazíme čas v showSteps2
		directionsDisplay.setMap(map);
		directionsDisplay.setOptions({ 
				preserveViewport: false,
				suppressMarkers: true,
				markerOptions: {map:null},
				polylineOptions: {
					strokeWeight: 4,
					strokeOpacity: 0.7,
					strokeColor:  '#456F9A' 
				}
		});
        directionsDisplay.setDirections(response);*/
        showSteps2(response,id_order);
      }
    });
  }
    
  function showSteps2(directionResult,id_order) {
    var distance = 0;
    var doba= 0;
    var myRoute = directionResult.routes[0];
    for (var i = 0; i < myRoute.legs.length; i++) {
      //distance=distance+myRoute.legs[i].distance.value;
      doba=doba+myRoute.legs[i].duration.value;
      doba=Math.round(doba/60*1.2);
    }
	if (doba!=0){
		//$("#mainpage_order_h1").html('<a href="" data-icon="info" onclick="zobrazitObjednavku(\''+id_order+'\');return false;">Přistavení za <span id="dojezd">'+doba+'</span> min.</a>');
		$("#order_text").html('Přistavení za <span id="dojezd">'+doba+'</span> min.');
	}
	else{
		//$("#mainpage_order_h1").html('<a href="" data-icon="info" onclick="zobrazitObjednavku(\''+id_order+'\');return false;">Přístavení do <span id="dojezd">1</span> minuty</a>'); 
		$("#order_text").html('Přístavení do <span id="dojezd">1</span> minuty');
 	}
  }
  
function debug(text){
	//alert (text);	
}