// JavaScript Document
$(document).on("pageshow", "#setting_kredit", function() {
	zkontroluj_setting_kredit();
	$('a[data-rel="back"]').show();
});

function zkontroluj_setting_kredit(){
	if (localStorage.login_token && localStorage.login_token!=""){
		var nocache = new Date().getTime();
		$.ajax({
		url: "http://www.facetaxi.cz/app/check_credit.php",
		type: "GET",
		crossDomain:true,
		dataType: "jsonp",
		data: '&telefon=' + localStorage.getItem("telefon") + '&login_token=' + localStorage.getItem("login_token") + '&nocache=4654' + nocache,
		beforeSend : function() {$.mobile.loading('show');},
		complete   : function() {$.mobile.loading('hide')},
		success: mysettingcredit,
		error : function (response, ajaxOptions, thrownError) {
			//alert(thrownError);
			//alert(response.status);
			$( "#status" ).html( response.status );
		  }
		});
	}
	else{
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	}
}

var mysettingcredit=function processSettingCreditData(data){
	if (data.status == "false"){
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	}
	else{
		if (data.kredit>1){
			$("#setting_kredit_value").html("Váš kredit je <strong>"+ data.kredit + " Kč</strong>");
		}
		else{
			$("#setting_kredit_value").html( "Zatím nemáte žádný kredit");
		}
		$("#facetaxi_ucet").html(data.facetaxi_ucet);
		$("#kredit_telefon").html(localStorage.telefon);
	}	
}

$(document).on("pageshow", "#setting_ucet", function() {
	$("#setting_name").val(localStorage.getItem("jmeno"));
	$("#setting_phone").val(localStorage.getItem("telefon"));
	$("#setting_email").val(localStorage.getItem("email"));
	$( "#setting_ucet_result" ).html();
	$('a[data-rel="back"]').show();
});

function upravit_udaje(){
	$.ajax({
		url: "http://www.facetaxi.cz/app/save_name_email.php",
		type: "GET",
		crossDomain:true,
		dataType: "jsonp",
		data: '&id_customer=' + localStorage.getItem("id_customer") + '&telefon=' + localStorage.getItem("telefon") + '&login_token=' + localStorage.getItem("login_token") + '&jmeno=' + $("#setting_name").val()  + '&email=' + $("#setting_email").val() ,
		success: myupravitudaje,
		error : function (response, ajaxOptions, thrownError) {
			$( "#setting_ucet_result" ).html( response.status );
		  }
	});
}
		
var myupravitudaje=function processUpdateNameData(data){
	if (data.status=="true"){
		localStorage.setItem("jmeno",data.jmeno);
		if (data.email_valid==1){
		  localStorage.setItem("email",data.email);
		}
		$( "#setting_ucet_result" ).html(data.message);
	}
	else{
		alert(data.message);
	}
}
$(document).on("pageshow", "#setting_heslo", function() {
	$('a[data-rel="back"]').show();
});

function nastavit_heslo(){
	$.ajax({
		url: "http://www.facetaxi.cz/app/save_heslo.php",
		type: "GET",
		crossDomain:true,
		dataType: "jsonp",
		data: '&id_customer=' + localStorage.getItem("id_customer") + '&telefon=' + localStorage.getItem("telefon") + '&login_token=' + localStorage.getItem("login_token") + '&heslo1=' + $("#setting_heslo1").val()  + '&heslo2=' + $("#setting_heslo2").val() ,
		success: mynastavitheslo,
		error : function (response, ajaxOptions, thrownError) {
			$( "#setting_heslo_result" ).html( response.status );
		  }
	});
}

var mynastavitheslo=function processUpdatePassData(data){
	if (data.status=="true"){
		$( "#setting_heslo_result" ).html(data.message);
	}
	else{
		alert(data.message);
	}
}

$(document).on("pageshow", "#oblibene_adresy", function() {
	nacti_oblibene_adresy();
//	historie_nacitani=setInterval(nacti_historii,10000);
	$('a[data-rel="back"]').show();
});
$(document).on("pagehide", "#oblibene_adresy", function() {
	//clearInterval(historie_nacitani);
});

function nacti_oblibene_adresy(){
	if (localStorage.getItem("login_token") && localStorage.getItem("login_token")!=""){
		var nocache = new Date().getTime();
		$.ajax({
		url: "http://www.facetaxi.cz/app/oblibene_adresy.php",
		type: "GET",
		crossDomain:true,
		dataType: "jsonp",
		data: '&telefon=' + localStorage.getItem("telefon") + '&login_token=' + localStorage.getItem("login_token") + '&nocache=4654' + nocache,
		beforeSend : function() {$.mobile.loading('show');},
		complete   : function() {$.mobile.loading('hide')},
		success: zpracujoblibene_adresy,
		error : function (response, ajaxOptions, thrownError) {
			//alert(thrownError);
			//alert(response.status);
			$( "#oblibene_adresy_content" ).html( response.status );
		  }
		});
	}
	else{
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	}
}

var zpracujoblibene_adresy=function processAdresyData(data){
	if (data.status == "false"){
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	}
	else{
		$( "#oblibene_adresy_content" ).html( data.historie ).trigger( "create" );
		$( "#oblibene_adresy_content ul li").attr('data-icon','arrow-1-e').trigger("refresh");
	}	
}

function add_oblibena_adresa_form(){
	$("#oblibene_adresy_form_header").html('Přidání oblíbené adresy');	
	$("#oblibene_adresy_add").show();
	$("#oblibene_adresy_update").hide();
	$("#update_id_adress").val(0);
	$("#oblibena_adresa_name").val('');
	$("#oblibena_adresa_adress").val('');
	$.mobile.changePage("#oblibene_adresy_form", { transition: "slidedown"});	
}

function add_oblibena_adresa(){
	if (localStorage.getItem("login_token") && localStorage.getItem("login_token")!==""){
		var nocache = new Date().getTime();
		$.ajax({
		url: "http://www.facetaxi.cz/app/add_oblibena_adresa.php",
		type: "GET",
		crossDomain:true,
		dataType: "jsonp",
		data: '&telefon=' + localStorage.getItem("telefon") + '&login_token=' + localStorage.getItem("login_token") + '&nazev=' + $("#oblibena_adresa_name").val() + '&adresa=' + $("#oblibena_adresa_adress").val() + '&nocache=4654' + nocache,
		beforeSend : function() {$.mobile.loading('show');},
		complete   : function() {$.mobile.loading('hide')},
		success: zpracujadd_oblibene_adresy,
		error : function (response, ajaxOptions, thrownError) {
			//alert(thrownError);
			//alert(response.status);
			$( "#oblibene_adresy_content" ).html( response.status );
		  }
		});
	}
	else{
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	} 
}

var zpracujadd_oblibene_adresy=function processAddAdresyData(data){
	if (data.status === "false"){
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	}
	else if (data.status === "invalid"){
		alert(data.message);
	}
	else{
		$.mobile.changePage("#oblibene_adresy", { transition: "slidedown"});
		nacti_oblibene_adresy();
	}	
}



function update_oblibena_adresa_form(id_adress){
	$("#oblibene_adresy_form_header").html('Úprava oblíbené adresy');	
	$("#oblibene_adresy_form_button_add").hide();
	$("#oblibene_adresy_form_button_update").show();
	$("#update_id_adress").val(id_adress);
	load_oblibena_adresa(id_adress);
	$.mobile.changePage("#oblibene_adresy_form", { transition: "slidedown"});	
}

function delete_oblibena_adresa(id_adress){
  if (confirm('Opravdu chcete vymazat tuto adresu?')) {
	if (localStorage.getItem("login_token") && localStorage.getItem("login_token")!==""){
		//autologin(localStorage.telefon,localStorage.login_token);
		var nocache = new Date().getTime();
		$.ajax({
		url: "http://www.facetaxi.cz/app/delete_oblibena_adresa.php",
		type: "GET",
		crossDomain:true,
		dataType: "jsonp",
		data: '&telefon=' + localStorage.getItem("telefon") + '&login_token=' + localStorage.getItem("login_token") + '&id_adress=' +id_adress+ '&nocache=4654' + nocache,
		beforeSend : function() {$.mobile.loading('show');},
		complete   : function() {$.mobile.loading('hide')},
		success: zpracujdelete_oblibene_adresy,
		error : function (response, ajaxOptions, thrownError) {
			//alert(thrownError);
			//alert(response.status);
			$( "#oblibene_adresy_content" ).html( response.status );
		  }
		});
	}
	else{
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	} 
  }
  else {
		// Do nothing!
  }
}

var zpracujdelete_oblibene_adresy=function processDelAdresyData(data){
	if (data.status === "false"){
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	}
	else if (data.status === "invalid"){
		alert(data.message);
	}
	else{
		nacti_oblibene_adresy();
	}	
}

// JavaScript Document
$(document).on("pageshow", "#vyber_oblibenou_adresu", function() {
	$( "#oblibena_adresa_naseptavac" ).html('');
	vychozi_oblibene();
	$( "#oblibena_adresa" ).keyup(function() {
	  generuj_naseptavac('oblibena_adresa');
	});
});


function vychozi_oblibene(){
	if (localStorage.getItem("login_token") && localStorage.getItem("login_token")!=""){
		$("#order_telefon").val(localStorage.getItem("telefon"));
		var nocache = new Date().getTime();
		$.ajax({
		url: "http://www.facetaxi.cz/app/historie_adres_oblibene.php",
		type: "GET",
		crossDomain:true,
		dataType: "jsonp",
		data: '&telefon=' + localStorage.getItem("telefon") + '&login_token=' + localStorage.getItem("login_token") + '&nocache=4654' + nocache,
		beforeSend : function() {$.mobile.loading('show');},
		complete   : function() {$.mobile.loading('hide')},
		success: zpracuj_oblibene_adresy,
		error : function (response, ajaxOptions, thrownError) {
			//alert(thrownError);
			//alert(response.status);
			$( "#oblibena_adresa_naseptavac" ).html( response.status );
		  }
		});
	}
	else{
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	}
}

var zpracuj_oblibene_adresy=function processOblibeneAdresyData(data){
	if (data.status == "false"){
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	}
	else{
		$( "#oblibena_adresa_naseptavac" ).html( data.historie ).trigger( "create" );
		$( "#oblibena_adresa_naseptavac ul li").attr('data-icon','false').trigger("refresh");
	}	
}

function vybratAdresuOblibene(addr){
	$("#oblibena_adresa").val(addr);
	$('#oblibena_adresa_naseptavac').html('');
	AdresaFinishedOblibene();
}

function AdresaFinishedOblibene(){
	//Provést kontrolu adresy a pak vyplnit do nadřazené stránky
	$("#oblibena_adresa_adress").val($("#oblibena_adresa").val());
	$.mobile.changePage("#oblibene_adresy_form", { transition: "slidedown"});	
}