// JavaScript Document
$(document).on("pageshow", "#vyber_adresu", function() {
	$( "#from_naseptavac" ).html('');
	$( "#from" ).keyup(function() {
	  generuj_naseptavac('from');
	});
});
$(document).on("pageshow", "#vyber_cil", function() {
	$( "#destination_naseptavac" ).html('');
	$( "#destination" ).keyup(function() {
	  generuj_naseptavac('destination');
	});
});

function generuj_naseptavac(element){
  adresa=$("#"+element).val();
  if (adresa.length>=1){
	$.ajax({
	url: "http://www.facetaxi.cz/app/naseptavac-debug.php",
	type: "GET",
	crossDomain:true,
	dataType: "jsonp",
	data: '&telefon=' + localStorage.getItem("telefon") + '&str=' + adresa + '&element=' + element,
	beforeSend : function() {$.mobile.loading('show');},
	complete   : function() {$.mobile.loading('hide')},
	success: mynaseptavac,
	error : function (response, ajaxOptions, thrownError) {
		alert(thrownError);
		//alert(response.status);
	  }
	});
  }
  else{//Vymažeme našeptávání
	$("#from_naseptavac").html('');
	$("#destination_naseptavac").html('');
  }
}

var mynaseptavac=function processNaseptavacData(data){
	if (data.status == "false"){
		//Nedotáhlo se nic
	}
	else{
		e = "#"+data.element+"_naseptavac";
		$( e ).html(data.message);
	}	
}