// JavaScript Document
var id_order=0;
var sleduji_vuz=0;
var odesila_se_objednavka=0;
var last_order=0;
var currentTime = new Date();
var month = currentTime.getMonth() + 1;
var day = currentTime.getDate();
var year = currentTime.getFullYear();
var hours = currentTime.getHours();
var minutes = currentTime.getMinutes();

if (minutes < 10){
minutes = "0" + minutes
}

$(document).on("pageinit", "#objednavka", function() {
	$( "#datum-pristaveni" ).val(day+"."+month+"."+year);
	$( "#cas-pristaveni" ).val(hours+":"+minutes);
	if (volnych_taxi==0){
		alert('Momentálně není volný vůz, jsou možné pouze předobjednávky.');
		$("#radio-view-a").attr("checked",false).checkboxradio("refresh");
		$("#radio-view-a").checkboxradio('disable').checkboxradio("refresh");;
		$("#radio-view-b").attr("checked",true).checkboxradio("refresh");
	}
	else{
		$("#radio-view-a").checkboxradio('enable').checkboxradio("refresh");;
	}
	$("input[name='predobjednavka']").change(function () {
		if($("#radio-view-a").attr('checked') == 'checked'){
			$("#pristaveni_fieldset3").hide();
		}
		else{
			$("#pristaveni_fieldset3").show();
		}
	 });
});

$(document).on("pageshow", "#objednavka", function() {
	 //Vypsání informací:
	 $("#addresa_text_o").html(""+$("#addresa_text").html());
	 if (existuje_cilova_adresa===1){
		 $("#destination_text_o").html(""+$("#destination_text").html());
		 $("#destination_text_o").show();
		 $("#odhad").show();
	 }
	 else{
		 $("#destination_text_o").hide();
		 $("#odhad").hide();
	 }
	 $("#start_td").html($("#pristaveni").val());
	 $("#destination").html($("#destination_text").val());
	 $("#jmeno").val(localStorage.jmeno);
	 if ($("#destinace").val()!=""){
		$("#destinace_tr").show();
	 	$("#destinace_td").html($("#destinace").val());
	 }
	 else{
		$("#destinace_tr").hide();
	 }
	if($("#radio-view-a").attr('checked') == 'checked'){
		$("#pristaveni_fieldset3").hide();
	}
	else{
		$("#pristaveni_fieldset3").show();
	}
	 zkontroluj_kredit();
	if (id_order>0){
		$("#order_control").show();
	}
});

$(document).on("pagehide", "#objednavka", function() {
	/*$("#ui-timepicker-div").hide();
	$("#ui-datepicker-div").hide();*/
});

$(document).on("pageinit", "#datum_cas", function() {
	
	$('#datum-pristaveni').datebox({
		mode: "calbox",
		afterToday: true,
		beforeToday: false,
		dateFieldOrder: ["d","m","y"],
		maxDays: 30,
		useLang: "cs"
	});
	
	$('#cas-pristaveni').datebox({
		mode: "timeflipbox",
		afterToday: false,
		minuteStep: 5,
		useLang: "cs"
	});
	
});

$(document).on("pagehide", "#datum_cas", function() {
	/*$("#ui-timepicker-div").hide();
	$("#ui-datepicker-div").hide();*/
});


function show_objednavka(){/*Kontrola adresy se děje už jen při jejím výběru, ne při potvrzení adresy*/
    var ulice = $( "#pristaveni" ).val();
	if (ulice.length>3){
		$.mobile.changePage("#objednavka", { transition: "slidedown"});
	}
	else{
		alert ("Nejprve prosím vyberte adresu přistavení.");
	}
}

function vuz_ihned(){
	$("#predobjednavka").val(0);
	$("#vuz_predobjednavka").removeClass("active");	
	$("#vuz_ihned").addClass("active");	
	$("#vuz_predobjednavka").html("Jiný čas přistavení");
}

function vuz_predobjednavka(){
	$.mobile.changePage("#datum_cas", { transition: "slidedown"});	
}

function dokonci_vuz_predobjednavka(){
	$("#predobjednavka").val(1);
	$("#vuz_predobjednavka").addClass("active");	
	$("#vuz_ihned").removeClass("active");	
	$("#vuz_predobjednavka").html($("#cas-pristaveni").val() + ", " + $("#datum-pristaveni").val());
	$.mobile.changePage("#objednavka", { transition: "slidedown"});	
}

function vuz_hotove(){
	$("#pouzit-kredit").val(0);
	$("#vuz_hotove").addClass("active");	
	$("#vuz_kredit").removeClass("active");	
	$("#vuz_hotove").html("Platím hotově");
	$("#vuz_kredit").html("Chci použít kredit");
}

function vuz_kredit(){
	$("#pouzit-kredit").val(1);
	$("#vuz_hotove").removeClass("active");	
	$("#vuz_kredit").addClass("active");
	$("#vuz_hotove").html("Chci platit hotově");
	$("#vuz_kredit").html("Jedu na kredit");
}

function zkontroluj_kredit(){
	if (localStorage.login_token && localStorage.login_token!=""){
		//autologin(localStorage.telefon,localStorage.login_token);
		$("#order_telefon").val(localStorage.telefon);
		if($("#radio-view-a").attr('checked') == 'checked'){
			var zkontroluj_predobjednavka=0;
		}
		else{
			var zkontroluj_predobjednavka=1;
		}
		$.ajax({
		url: "http://www.facetaxi.cz/app/check_credit.php",
		type: "GET",
		crossDomain:true,
		dataType: "jsonp",
		data: '&telefon=' + localStorage.getItem("telefon") + '&login_token=' + localStorage.getItem("login_token") + '&pristaveni_lat=' + $("#pristaveni_lat").val() + '&pristaveni_lng=' + $("#pristaveni_lng").val() + '&predobjednavka=' + zkontroluj_predobjednavka ,
		beforeSend : function() {$.mobile.loading('show');},
		complete   : function() {$.mobile.loading('hide')},
		success: mycredit,
		error : function (response, ajaxOptions, thrownError) {
			$( "#status" ).html( response.status );
		  }
		});
	}
	else{
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	}
}

var mycredit=function processCreditData(data){
	if (data.status == "false"){
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	}
	else{
		if (data.vuz_daleko!=''){
			$("#order_error").html(data.vuz_daleko);
			$("#order_error").show();
		}
		else{
			$("#order_error").hide();
			$("#order_error").html();	
		}
		$( "#kredit" ).val( data.kredit );
		
		if (data.kredit>1){
			$("#kredit_nekredit_content").show();
			$( "#kredit_text" ).html("Váš aktuální kredit je: <strong>" + data.kredit + "Kč</strong>");
			$( "#kredit_text" ).show();
		}
		else{
			$("#kredit_nekredit_content").hide();
			$( "#kredit_text" ).html();
			$( "#kredit_text" ).hide;
		}
	}	
}

$(document).on("pageshow", "#order_finished", function() {
	$('a[data-rel="back"]').hide();
});
$(document).on("pagehide", "#order_finished", function() {
	$('a[data-rel="back"]').show();
});

function objednej(){
	if (localStorage.getItem("login_token") && localStorage.getItem("login_token")!=""){
		var ted=new Date().getTime();
		if (ted>(last_order+2500) && odesila_se_objednavka==0){
			odesila_se_objednavka=1;
			last_order=new Date().getTime();
			$("#order_telefon").val(localStorage.getItem("telefon"));
			$.ajax({
			url: "http://www.facetaxi.cz/app/save_order.php",
			type: "GET",
			crossDomain:true,
			dataType: "jsonp",
			data: $("form#orderform").serialize()+'&id=' + localStorage.getItem("id_customer") + '&telefon=' + localStorage.getItem("telefon") + '&login_token=' + localStorage.getItem("login_token") + '&lat=' + pristaveni_lat + '&lng=' + pristaveni_lng + '&gps=' + senzor_gps + '&acc=' + global_accuracy + "&datum-pristaveni=" + $("#datum-pristaveni").val() + "&cas-pristaveni=" + $("#cas-pristaveni").val(),
			beforeSend : function() {$.mobile.loading('show');},
			complete   : function() {$.mobile.loading('hide')},
			success: myorderstatus,
			error : function (response, ajaxOptions, thrownError) {
				$( "#status" ).html( thrownError );
			  }
			});
		}
		else{
			if (ted>(last_order+2500)){
				alert("Objednávka se již odesílá, vyčkejte jejího zpracování.");	
			}
		}
	}
	else{
		$.mobile.changePage("#loginpage", { transition: "slidedown"});	
	}
}

var objednanicheck;
var objednani_timeout='NULL';
var objednani_ceka_timeout='NULL';

var myorderstatus=function processOrderData(data){
	if (data.status === "false"){
		alert(data.message);
	}
	else{
		//Reset trasy po odeslání objednávky
		$("#poznamka").val("");
		$("#from").val("");
		$("#pristaveni").val("");
		$("#addresa_text").html("<aside>A</aside><strong>Hledáme adresu</strong>Vyčkejte či vyberte adresu přistavení");
		$("#destinace").val('');
		$("#destination_text").html("<aside>B</aside><strong>Cílová adresa</strong>Zadejte či vyberte adresu");
		if (start_marker!=='NULL'){start_marker.setMap(null);}
		if (cil_marker!=='NULL'){cil_marker.setMap(null);}
		directionsDisplay.setDirections({routes: []});
		hide_cil();
		$("#castka_text").html("");
		vuz_hotove();
		vuz_ihned();
		
		//Zobrazení outputu objednávky
		if (data.predobjednavka===1){
			$.mobile.changePage("#order_finished", { transition: "slidedown"});
			$("#order_h1").html(data.header);
			$("#order_status").html(data.success).trigger( "create" );
			$("#order_track_button").hide();
			$("#storno_button").show();
			$("#order_back_button").show();
			$("#storno_button_main").show();
			id_order=data.id_order;
		}
		else{
			$.mobile.changePage("#order_finished", { transition: "slidedown"});
			$("#order_h1").html(data.header);
			$("#order_status").html(data.success).trigger( "create" );
			//$("#order_back_button").hide();
			$("#order_track_button").hide();
			$('#storno_button').show();
			$('#storno_button_main').show();
			$('#storno_button_finished').show();
			$("#order_back_button").hide();
			id_order=data.id_order;
			objednanicheck=setInterval(function(){objednavka_check(data.id_order);},1000);
			objednani_ceka_timeout=setTimeout(function(){objednavka_cekat(data.id_order);},25000);
			objednani_timeout=setTimeout(function(){objednavka_neprijata(data.id_order);},50000);
		}
	}
	odesila_se_objednavka=0;
}

function objednavka_cekat(id){
	clearTimeout(objednani_ceka_timeout);
	$("#storno_button").show();
	$("#order_back_button").hide();
	$("#order_status").html('<p style="font-size:1.2em;margin-top:15px;text-align:center;"><strong>Omlouváme se,</strong><br /> nenašli jsme pro Vás volný vůz.</p>'+
	'<p style="font-size:1.2em;margin-top:30px;text-align:center;font-wight:bold;">Přejete si počkat na první volný vůz ve Vašem okolí?</p>'+
	'<div class="ui-grid-a ui-responsive">'+
	'<div class="ui-block-a" style="margin-top:20px;"><a href="#" class="ui-btn ui-shadow ui-corner-all" onclick="do_nabidek('+id+');return false;" style="padding-top:10px;padding-bottom:10px;background:green;color:#fff;text-decoration:none;">ANO</a></div>'+
	'<div class="ui-block-b" style="margin-top:20px;"><a href="#" class="ui-btn ui-shadow ui-corner-all" onclick="objednavka_neprijata('+id+');return false;" style="padding-top:10px;padding-bottom:10px;background:red;color:#fff;text-decoration:none;">NE</a></div>'+
	'</div>').trigger( "create" );
	$("#order_status").trigger("refresh");
}

function do_nabidek(id){
	clearTimeout(objednani_timeout);
	clearTimeout(objednani_ceka_timeout);
	//clearInterval(objednanicheck);
	$('#storno_button_finished').show();
	$("#order_back_button").show();
	/*Odešleme do systému a změníme na stav -5*/
	id = typeof id !== 'undefined' ? id : id_order;
	$.ajax({
		url: "http://www.facetaxi.cz/app/order_do_nabidek.php",
		type: "GET",
		crossDomain:true,
		dataType: "jsonp",
		data: '&id_customer=' + localStorage.getItem("id_customer") + '&login_token=' + localStorage.getItem("login_token") + '&id_order=' + id,
		success: myordernabidek,
		error : function (response, ajaxOptions, thrownError) {
			$( "#status" ).html( response.status );
		  }
	});
}


var myordernabidek=function processNabidkaData(data){
	//alert(data.get);
	if (data.status == "false"){
		$("#order_status").html('<p style="font-size:1.2em;margin-top:100px;text-align:center;">'+data.message+'</p>');
	}
	else{
		if (data.status=="true"){
			$("#order_status").html('<p style="font-size:1.2em;margin-top:100px;text-align:center;">'+data.message+'</p>');
		}
		else{
			alert(data.message);
		}
	}	
}

function objednavka_neprijata(id){
	$("#storno_button").hide();
	$("#storno_button_main").hide();
	$("#order_back_button").show();
	$("#order_detail_storno_button").hide();
	$("#order_status").html('<p style="font-size:1.2em;margin-top:100px;text-align:center;"><strong>Omlouváme se,</strong><br /> nenašli jsme pro Vás volný vůz. Zkuste objednat později.</p>');
	clearTimeout(objednani_timeout);
	clearTimeout(objednani_ceka_timeout);
	clearInterval(objednanicheck);
	storno_order_auto(id);
}

function objednavka_check(cislo){
	$.ajax({
	url: "http://www.facetaxi.cz/app/objednavka_check.php",
	type: "GET",
	crossDomain:true,
	dataType: "jsonp",
	data: '&id_customer=' + localStorage.getItem("id_customer") + '&cislo=' + cislo,
	success: myordercheck,
	error : function (response, ajaxOptions, thrownError) {
		$( "#status" ).html( response.status );
	  }
	});
}

var myordercheck=function processCheckData(data){
	if (data.status === "false"){
		//Nic
	}
	else{
		clearTimeout(objednani_timeout);
		clearTimeout(objednani_ceka_timeout);
		if (data.status==="true"){
			clearInterval(objednanicheck);
			$("#order_status").html(data.message);
			id_taxikar=data.id_taxikar;
			id_order=data.id_order;
			$("#order_control").show();
			$("#order_track_button").show();
			$("#storno_button_finished").show();
			$("#order_back_button").show();
		    $('a[data-rel="back"]').hide();
			//vuz_ihned();
		}
		else if (data.status==="storno"){
			clearInterval(objednanicheck);
			$("#order_status").html(data.message);
			$("#order_control").show();
			$("#order_track_button").hide();
			$("#order_back_button").show();
		    $('a[data-rel="back"]').hide();
			$("#storno_button_finished").hide();
			$("#storno_button").hide();
		}
		else{
			$("#order_h1").html("Došlo k chybě");
			$("#order_status").html(data.message);
			$("#order_control").show();
			$("#order_track_button").hide();
			$("#order_back_button").show();
		    $('a[data-rel="back"]').hide();
			$("#storno_button_finished").hide();
			$("#storno_button").hide();
		}
	}	
}

function primo_sleduj_vuz(id){
		id_order=id;
		sleduj_vuz();
	}

function sleduj_vuz(){
	sleduji_vuz=1;
	$("#cil").css('visibility','hidden');
	$("#cil").hide();
	hide_cil();
	$.mobile.changePage("#mainpage", { transition: "slidedown"});
	getMarkers();
	//$("#setting_button").hide();
	//$('a[data-rel="back"]').show();
	clearInterval(markers_interval);
	$("#gps_arrow").hide();$("#gps_search").hide();
	markers_interval=setInterval(getMarkers, 6000);
}

function nesleduj_vuz(){
	sleduji_vuz=0;
	directionsDisplay.setDirections({routes: []});
	getMarkers();
	clearInterval(markers_interval);
	$("#gps_arrow").hide();$("#gps_search").show();
	markers_interval=setInterval(getMarkers, 6000);
	$("#cil").css('visibility','visible');
	$("#cil").show();
	if(fixed_price===1){
		show_cil();
	}
	else{
		hide_cil();
	}
	start_watch();
}

function storno_order(id_storno_order){
	if (confirm('Opravdu chcete stornovat tuto objednávku?')) {
		id_storno_order = typeof id_storno_order !== 'undefined' ? id_storno_order : id_order;
		clearTimeout(objednani_timeout);
		clearTimeout(objednani_ceka_timeout);
		clearInterval(objednanicheck);
		if (id_storno_order>0){
			$.ajax({
				url: "http://www.facetaxi.cz/app/storno_order.php",
				type: "GET",
				crossDomain:true,
				dataType: "jsonp",
				data: '&id_customer=' + localStorage.getItem("id_customer") + '&login_token=' + localStorage.getItem("login_token") + '&id_order=' + id_storno_order,
				success: myorderstorno,
				error : function (response, ajaxOptions, thrownError) {
					$( "#status" ).html( response.status );
				  }
			});
		}
		id_order=0;
		id_taxikar=0;
	} else {
		// Do nothing!
	}
}

var myorderstorno=function processStornoData(data){
	//alert(data.get);
	if (data.status == "false"){
		alert(data.message);
	}
	else{
		if (data.status=="true"){
			//alert(data.message);
			$.mobile.changePage("#mainpage", { transition: "slidedown"});
			nesleduj_vuz();
			$("#storno_button_finished").hide();
			$("#storno_button").hide();
		}
		else{
			alert(data.message);
		}
	}	
}

function storno_order_auto(id_storno_order){
		id_storno_order = typeof id_storno_order !== 'undefined' ? id_storno_order : id_order;
		$.ajax({
			url: "http://www.facetaxi.cz/app/storno_order_vuz.php",
			type: "GET",
			crossDomain:true,
			dataType: "jsonp",
			data: '&id_customer=' + localStorage.getItem("id_customer") + '&login_token=' + localStorage.getItem("login_token") + '&id_order=' + id_storno_order,
			success: myorderautostorno,
			error : function (response, ajaxOptions, thrownError) {
				$( "#status" ).html( response.status );
			  }
		});
		id_order=0;
		id_taxikar=0;
}

var myorderautostorno=function processAutoStornoData(data){
	//alert(data.get);
	if (data.status == "false"){
		alert(data.message);
	}
	else{
		if (data.status=="true"){
			$("#storno_button_finished").hide();
			$("#storno_button").hide();
		}
		else{
			alert(data.message);
		}
	}	
}